# add mod_python package

Name:		trac
Version: 0.8.1
Release: %mkrel 2
License:	GPL
Group:		Networking/WWW
Summary:	Integrated SCM & Project manager
Source0:    http://ftp.edgewall.com/pub/trac/%{name}-%{version}.tar.bz2
Source1:    tracd.init.bz2
Source2:    tracd.sysconfig.bz2
Source3:    Trac.pm.bz2
Patch0:     tracd.daemon.patch.bz2 
Url:		http://projects.edgewall.com/trac/wiki/TracDownload
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: python-devel 
Requires:   python-clearsilver subversion-repos 
Requires:   python-subversion python-sqlite
Requires:   %{name}-frontend
BuildArch:  noarch 
%description
Trac is a minimalistic web-based software project management
and bug/issue tracking system. It provides an interface to
revision control systems (Subversion), an integrated 
Wiki and convenient report facilities. 


%package cgi
Group:		Networking/WWW
Summary:	Trac Integrated SCM & Project manager - cgi frontend
Group:		Networking/WWW
Requires:       %{name}
# it can work with any cgi webserver, but only apache is covered by the package
Requires: webserver
Provides:       %{name}-frontend

%description cgi
Trac is a minimalistic web-based software project management
and bug/issue tracking system. It provides an interface to
revision control systems (Subversion), an integrated 
Wiki and convenient report facilities. 

This package contains various files needed to integrate it
with apache.

%package -n drakwizard-%{name}
Group:		System/Configuration/Other
Summary:	Trac Integrated SCM & Project manager - project creation wizard


%description -n drakwizard-%{name}
Trac is a minimalistic web-based software project management
and bug/issue tracking system. It provides an interface to
revision control systems (Subversion), an integrated 
Wiki and convenient report facilities. 

This package provides a wizard to create trac multiple project
repository using tracd.

You can access it with drakwizard or with Mandrake control center.


%package standalone
Group:		Networking/WWW
Summary:	Trac Integrated SCM & Project manager - standalone frontend
Requires:       %{name}
Provides:       %{name}-frontend
PreReq:         rpm-helper

%description standalone
Trac is a minimalistic web-based software project management
and bug/issue tracking system. It provides an interface to
revision control systems (Subversion), an integrated 
Wiki and convenient report facilities. 

This package contains various files needed to run as standalone
http server.

%prep
%setup -q
%patch -p0

%build
cat > README.upgrade.urpmi << EOF
Trac changed the format of the database since the last release.
See the file UPGRADE, in %_defaultdocdir/%{name}-%{version}/.

In order to ease the installation, and provides more modularity, 
trac package have been split in 2 frontends. You can choose 
%{name}-standalone for a version with tracd, or %{name}-cgi 
for the previous system. 

EOF

cat > trac.conf << EOF
Alias /trac/ "/usr/share/trac/htdocs/"

# Trac need to know where the database is located
#<Location "/cgi-bin/trac.cgi">
#        SetEnv TRAC_ENV "/somewhere/myproject.env/"
#</Location>

# You need this to allow users to authenticate
#<Location "/cgi-bin/trac.cgi/login">
#        AuthType Basic
#        AuthName "trac"
#        AuthUserFile /somewhere/trac.htpasswd
#        Require valid-user
#</location>
EOF

cat > wizard.trac.conf << EOF
NAME="Trac"
DESCRIPTION="Trac wizard ( project management software )"
LONG_DESCRIPTION="A wizard to setup a bugtracking system"
EOF

cat > README.wizard << EOF
Since many peoples complains that wizards do not help to understand their
system, here is a quick summary of this wizard actions, and how to do the
same by hand :

1) subversion repository creation ( if it do not exist )
$ svnadmin create --fs-type fsfs \$DIRECTORY

fsfs was chosen over bdbd because it is more robust, according to trac
developers.

2) trac repository creation
$ trac-admin \$TRAC_REPOSITORY_PATH initenv \$PROJECT_NAME

3) integration with tracd
in order to use your new trac project, you need to add it to tracd config 
file, in /etc/sysconfig/tracd. All you need is to add it to PROJECT,
and reload tracd, with service tracd restart.

EOF
%install

rm -rf $RPM_BUILD_ROOT
python ./setup.py install --prefix=$RPM_BUILD_ROOT/%_prefix

#change default config
perl -pi -e "s#$RPM_BUILD_ROOT##" $RPM_BUILD_ROOT/%{_libdir}/python%{pyver}/site-packages/%{name}/siteconfig.py
rm -f $RPM_BUILD_ROOT/%{_libdir}/python%{pyver}/site-packages/%{name}/siteconfig.pyc

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/

cp trac.conf  $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/

mkdir -p $RPM_BUILD_ROOT/var/www/cgi-bin
mv $RPM_BUILD_ROOT/%{_datadir}/%name/cgi-bin/trac.cgi $RPM_BUILD_ROOT/var/www/cgi-bin/

mkdir -p $RPM_BUILD_ROOT/%{_initrddir}
bzcat %{SOURCE1} >  $RPM_BUILD_ROOT/%{_initrddir}/%{name}d 
chmod 0755 $RPM_BUILD_ROOT/%{_initrddir}/%{name}d

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/
bzcat %{SOURCE2} >  $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/%{name}d

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/wizard.d/
cp wizard.trac.conf $RPM_BUILD_ROOT/%{_sysconfdir}/wizard.d/%{name}.conf

mkdir -p $RPM_BUILD_ROOT/%{perl_vendorlib}/MDK/Wizard/
bzcat %{SOURCE3} >  $RPM_BUILD_ROOT/%{perl_vendorlib}/MDK/Wizard/Trac.pm

%clean
rm -rf $RPM_BUILD_ROOT

%post cgi
%{_initrddir}/httpd reload

%postun cgi
%{_initrddir}/httpd reload

%post standalone
%_post_service tracd

%preun standalone
%_preun_service tracd

%files
%defattr(-,root,root)
%doc AUTHORS  ChangeLog README COPYING 
%doc INSTALL   RELEASE UPGRADE doc THANKS contrib
%doc README.upgrade.urpmi

%{_datadir}/%{name}
%{_bindir}/%{name}-admin
%{_bindir}/%{name}db2env
%_mandir/man1/*

%{_libdir}/python%{pyver}/site-packages/%{name}/

%files standalone
%defattr(-,root,root)
%doc README.tracd
%config(noreplace) %{_initrddir}/%{name}d
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}d
%{_bindir}/%{name}d

%files cgi
%defattr(-,root,root)
/var/www/cgi-bin/%{name}.cgi
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf

%files -n drakwizard-%{name}
%defattr(-,root,root)
%doc README.wizard
%{perl_vendorlib}/MDK/Wizard/*
%config(noreplace) %{_sysconfdir}/wizard.d/%{name}.conf

%changelog
* Fri Mar 11 2005 Michael Scherer <misc@mandrake.org> 0.8.1-2mdk 
- add wizard
- add %%mkrel

* Fri Mar 04 2005 Lenny Cartier <lenny@mandrakesoft.com> 0.8.1-1mdk
- 0.8.1

* Sun Dec 05 2004 Michael Scherer <misc@mandrake.org> 0.8-2mdk
- Rebuild for new python

* Sun Nov 21 2004 Michael Scherer <misc@mandrake.org> 0.8-1mdk 
- New release 0.8
- split tracd and cgi support
- patch for tracd daemonisation

* Fri Jun  4 2004 Michael Scherer <misc@mandrake.org> 0.7.1-1mdk
- New release 0.7.1

* Wed May 19 2004 Michael Scherer <misc@mandrake.org> 0.7-1mdk
- New release 0.7
- update config files

* Wed Apr 14 2004 Michael Scherer <misc@mandrake.org> 0.6.1-2mdk 
- remove compiled config file, with wrong path inside

* Mon Apr 12 2004 Michael Scherer <misc@mandrake.org> 0.6.1-1mdk
- New release 0.6.1
- add support for rpmbuildupdate

* Fri Apr 02 2004 Michael Scherer <misc@mandrake.org> 0.6-1mdk
- First Mandrakesoft Package

